Subject: Re: [icnrg] Proposed Hackathon Project: Using ICN for critical, time sensitive systems

From: Peter Maynard <[email-masked]>
Date: Mon, 12 Mar 2018 12:06:17 +0000

Hi Dirk, 

Sorry for the delay.

On Wed, 2018-02-28 at 15:07 +0100, Dirk Kutscher wrote:
> Hi Pete,
> 
> > I had planned to attend both days of the Hackathon. Arriving with
> > some
> > equipment depending on how much space I have either a) raspberry pi
> > with LEDs to simulate traffic lights, b) spare laptop with IEC104
> > emulator.
> > 
> > Before the event we will identify some key performance measurements
> > which apply to critical infrastructure and get some baselines of
> > the
> > current systems running over TCP/IP.
> > 
> > Depending on who is there and what people are interested in, I
> > propose
> > two approaches:
> > 
> > - Map IEC60870-5-101/4 to CCN/NDN with modification of the IEC104
> > emulator to have native ICN communication.
> > - Develop an application gateway to translate IEC104 communication
> > to
> > the RPI. (using IEC104 java library)
> 
> OK, great. It sounds like you have a focus on IEC 60870. In the IIoT 
> world, many people are looking into TSN & OPC UA these days. Is that 
> something that you are looking into or working with, too?

Absolutely, this would be something to look into. I've not worked with
either of these, but would be interested most in OPC UA, as we have
some equipment which can talk with it.

> > Now, my experience with ICN is next to nothing, so I am still
> > working
> > through your current publications and existing work. I will be more
> > than happy to provide you with a better summary and discussion
> > (either
> > at a meeting or online) once I have finished my analysis.
> 
> That would be very useful.
> 
> Since this is relatively short-notice, and not many ICN folks may be 
> very familiar with IEC 60870, it might be a good idea to allocate a
> good 
> portion of the time to some form of tutorial and design discussion.

I agree this makes sense. 

> Regarding ICN intro material, check out the tutorials at ACM ICN-
> 2017: 
> https://conferences.sigcomm.org/acm-icn/2017/
> 
> 
> Note that there is an ICNRG meeting on Sunday, so that could
> conflict 
> with Hackathon activities.

I might be too late to get a slot at the meeting as it appears you have
finalised the agenda. If there is space I would be happy to give a
quick overview, if not I plan to attend some of the meeting. 

> In any case, I think it would be great to start a thread (and some 
> activity in ICNRG) on ICN for time sensitive systems — you would be 
> most welcome to share your thoughts.

I am going to add the details of the project to the hackathon wiki and
get that going for at least the Saturday.

> Best regards,
> Dirk
> 
> 
> 
> > Kind Regards,
> > Pete
> > 
> > On Tue, 2018-02-27 at 09:15 +0100, Dirk Kutscher wrote:
> > > Hi Pete,
> > > 
> > > That sounds like a very interesting idea.
> > > 
> > > I’d be interested to discuss this further — have you made any 
> > > plans
> > > regarding dates, organization of the hackathon etc.?
> > > 
> > >  From a timing perspective, Saturday before the IETF could be a
> > > good
> > > day.
> > > 
> > > Let us know in case there is anything we can do to support this.
> > > 
> > > It would also be great to have a summary plus further discussion
> > > at
> > > one
> > > of the ICNRG meetings.
> > > 
> > > Cheers,
> > > Dirk
> > > 
> > > 
> > > 
> > > On 26 Feb 2018, at 18:51, Peter Maynard wrote:
> > > 
> > > > Dear all,
> > > > 
> > > > I would like to get your feedback on my proposal of a Hackathon
> > > > project
> > > > at the next meet up in London. I'm currently researching
> > > > ICS/SCADA
> > > > network security at Queen's University Belfast.
> > > > 
> > > > Many SCADA protocols were originally developed for serial links
> > > > and
> > > > were then moved to TCP/IP systems. Because of this current
> > > > deployments
> > > > are vulnerable to MITM attacks due to lack of authentication
> > > > and
> > > > encryption. Also, the nature of SCADA systems match well with a
> > > > publish/subscribe model. Since there are many devices being
> > > > monitored
> > > > for updates. e.g. consider a heating system with multiple
> > > > temperature
> > > > sensors throughout the building.
> > > > 
> > > > I would like to champion a project at the hackathon to expand
> > > > on a
> > > > use
> > > > case, 'Using ICN for critical, time sensitive systems'. Such as
> > > > in
> > > > a
> > > > process control network that is an air-gaped network with
> > > > sensors
> > > > and
> > > > actuators. The intention is to identify some key indicators as
> > > > to
> > > > the
> > > > feasibility of an ICN architecture in SCADA systems.
> > > > 
> > > > Depending on your feedback, I propose we develop one of two
> > > > things:
> > > > 1)
> > > > Map a protocol to an ICN implementation CCN/NDN; 2) Develop an
> > > > application gateway to translate for the device.
> > > > 
> > > > Objectives
> > > > ----------
> > > > - Map a field bus protocol (IEC101/4) to ICN.
> > > > - Develop an application gateway to a:
> > > > 	- a) Physical PLC
> > > > 	- b) Raspberry PI Traffic lights
> > > > 	- c) VM software based PLC emulator
> > > > - Define key performance indicators (KPI) for SCADA systems.
> > > > 	-
> > > > Compare TCP/IP to ICN using KPI.
> > > > 	- Needs to be real-time andreliable, redundant path
> > > > comms.
> > > > - Develop a HMI web interface to control remove device over
> > > > ICN.
> > > > 
> > > > Thank you for your time,
> > > > Any feedback is welcomed.
> > > > 
> > > > kind Regards,
> > > > Pete Maynard
> > > > 
> > > > -- 
> > > > Pete Maynard
> > > > Centre for Secure Information Technologies
> > > > Queen's University Belfast
> > > > GPG: 0xABB8D69D
> > > > https://petermaynard.co.uk | @pgmaynard
> > > > _______________________________________________
> > > > icnrg mailing list
> > > > [email-masked]
> > > > https://www.irtf.org/mailman/listinfo/icnrg
> > 
> > -- 
> > Pete Maynard
> > Centre for Secure Information Technologies
> > Queen's University Belfast
> > GPG: 0xABB8D69D
> > https://petermaynard.co.uk | @pgmaynard
> > _______________________________________________
> > icnrg mailing list
> > [email-masked]
> > https://www.irtf.org/mailman/listinfo/icnrg
-- 
Pete Maynard
Centre for Secure Information Technologies 
Queen's University Belfast
GPG: 0xABB8D69D
https://petermaynard.co.uk | @pgmaynard